SystemOrganization addCategory: #'PBE-LightsOut'!

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell methodsFor: 'initialization' stamp: 'ArnoldCondori 9/23/2012 13:03'!
initialize 
	super initialize.
	self label:''.
	self borderWidth: 2.
	bounds  := 0@0 corner: 16@16.
	offColor  := Color paleYellow.
	onColor := Color paleMagenta darker .
	self useSquareCorners.
	self turnOff! !

!LOCell methodsFor: 'accessing' stamp: 'ArnoldCondori 9/23/2012 10:36'!
mouseAction: aBlock 
	^mouseAction := aBlock ! !

!LOCell methodsFor: 'event handling' stamp: 'ArnoldCondori 9/23/2012 10:38'!
mouseUp: anEvent
	mouseAction value ! !

BorderedMorph subclass: #LOGame
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame methodsFor: 'initialization' stamp: 'ArnoldCondori 9/23/2012 13:08'!
cellsPerSide
	"The number of cells along each side of the game"
	^26! !

!LOGame methodsFor: 'initialization' stamp: 'ArnoldCondori 9/23/2012 12:42'!
initialize 
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell  new.
	width := sampleCell width.
	height :=sampleCell height.
	self bounds: (5@5 extent: ((width *n)@(height*n))+(2* self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j].! !

!LOGame methodsFor: 'initialization' stamp: 'ArnoldCondori 9/23/2012 10:58'!
mouseMove: anEvent! !

!LOGame methodsFor: 'initialization' stamp: 'ArnoldCondori 9/23/2012 12:59'!
newCellAt:i at:j
	"Create a cell for position (i,j) and add it to my on-screen representation at the appropriate screen position. Answer the new cell"
	| c origin |
	c := LOCell new.
	origin := self innerBounds  origin.
	self addMorph: c.
	c position: ((i-1)* c width) @ ((j-1)* c height  ) + origin.
	c mouseAction: [self toggleNeighboursOfCellAt:i at:j].
	^c! !

!LOGame methodsFor: 'game logic' stamp: 'ArnoldCondori 9/23/2012 13:08'!
toggleNeighboursOfCellAt:i at:j 
	(i>2) ifTrue:  [ (cells at:i-2  at:j ) toggleState].
	(i< self cellsPerSide ) ifTrue: [ (cells at: i+2 at:j) toggleState].
	(j>2) ifTrue:  [ (cells at:i  at:j-2 ) toggleState].
	(j< self cellsPerSide ) ifTrue: [(cells at:i at:j+2 ) toggleState].

	! !
